/*
 * TestTransaction.java
 */

package webpay.client.test;

import webpay.client.Webpay;

import java.io.*;
import javax.swing.*;
import java.awt.*;
import java.io.*;
import java.util.*;

/**
 * @author  Webpay
 *
 * This class is a simple test application for testing the Webpay payment API
 * for credit card transactions.
 *
 * It performs purchases and refunds.  Refunds, depending on the server configuration,
 * typicaly require the original transaction reference (so that refunds can only
 * be performed up to the original transaction amount).
 *
 */

public class TestTransaction extends javax.swing.JDialog
{
  private JFileChooser fc = new JFileChooser();
  private java.awt.Label label1;
  private java.awt.Label label2;
  private java.awt.Label label3;
  private java.awt.Label label4;
  private java.awt.Label label5;
  private java.awt.Label label6;
  private java.awt.Label label7;
  private java.awt.Label label8;
  private java.awt.Label label9;
  private java.awt.List resultList;
  private java.awt.TextField port;
  private java.awt.TextField expMonth;
  private java.awt.TextField gateway;
  private java.awt.TextField passphrase;
  private java.awt.TextField originalRef;
  private java.awt.TextField expYear;
  private java.awt.TextField clientid;
  private java.awt.TextField amount;
  private java.awt.TextField certificate;
  private java.awt.TextField cardNum;
  private java.awt.Checkbox refund;
  private javax.swing.JButton execute;
  private javax.swing.JButton selectFile;

  public TestTransaction(java.awt.Frame parent, boolean modal)
  {
    super(parent, modal);
    initComponents();
    
    setSize(370,490);
    setLocation(250,100);
    setTitle("Test Transaction");
    
    fc.setDialogTitle("Certificate...");
  }
  
  private void initComponents()
  {
    label1 = new java.awt.Label();
    label2 = new java.awt.Label();
    label3 = new java.awt.Label();
    label4 = new java.awt.Label();
    label5 = new java.awt.Label();
    label6 = new java.awt.Label();
    label7 = new java.awt.Label();
    label8 = new java.awt.Label();
    label9 = new java.awt.Label();
    resultList = new java.awt.List();
    cardNum = new java.awt.TextField();
    expMonth = new java.awt.TextField();
    expYear = new java.awt.TextField();
    certificate = new java.awt.TextField();
    passphrase = new java.awt.TextField();
    amount = new java.awt.TextField();
    gateway = new java.awt.TextField();
    port = new java.awt.TextField();
    clientid = new java.awt.TextField();
    originalRef = new java.awt.TextField();
    refund = new java.awt.Checkbox();
    selectFile = new javax.swing.JButton();
    execute = new javax.swing.JButton();

    getContentPane().setLayout(new AbsoluteLayout());

    setName("Test Transaction");
    addWindowListener(new java.awt.event.WindowAdapter()
    {
      public void windowClosing(java.awt.event.WindowEvent evt)
      {
        closeDialog(evt);
      }
    });

    execute.setBackground(new java.awt.Color(255, 51, 51));
    execute.setText("Execute");
    execute.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        executeActionPerformed(evt);
      }
    });

    getContentPane().add(execute, new AbsoluteConstraints(10, 190, 340, -1));

    getContentPane().add(resultList, new AbsoluteConstraints(10, 220, 340, 220));

    cardNum.setText("4564456445644564");
    getContentPane().add(cardNum, new AbsoluteConstraints(100, 100, 250, -1));

    expMonth.setText("12");
    getContentPane().add(expMonth, new AbsoluteConstraints(100, 130, 30, -1));

    label1.setAlignment(java.awt.Label.RIGHT);
    label1.setText("Card Number");
    getContentPane().add(label1, new AbsoluteConstraints(0, 100, 90, -1));

    expYear.setText("10");
    getContentPane().add(expYear, new AbsoluteConstraints(140, 130, 30, -1));

    label2.setAlignment(java.awt.Label.RIGHT);
    label2.setText("Exp Date");
    getContentPane().add(label2, new AbsoluteConstraints(10, 130, 80, -1));

    certificate.setText("(filename)");
    getContentPane().add(certificate, new AbsoluteConstraints(100, 10, 200, -1));

    label3.setAlignment(java.awt.Label.RIGHT);
    label3.setText("Certificate");
    getContentPane().add(label3, new AbsoluteConstraints(10, 10, 80, -1));

    label4.setAlignment(java.awt.Label.RIGHT);
    label4.setText("Passphrase");
    getContentPane().add(label4, new AbsoluteConstraints(10, 40, 80, -1));

    passphrase.setText("webpay");
    passphrase.setEchoChar('*');
    getContentPane().add(passphrase, new AbsoluteConstraints(100, 40, 110, -1));

    label5.setAlignment(java.awt.Label.RIGHT);
    label5.setText("Amount $");
    getContentPane().add(label5, new AbsoluteConstraints(200, 130, 70, -1));

    amount.setText("10.08");
    getContentPane().add(amount, new AbsoluteConstraints(280, 130, 70, -1));

    label6.setAlignment(java.awt.Label.RIGHT);
    label6.setText("Port");
    getContentPane().add(label6, new AbsoluteConstraints(230, 70, 40, -1));

    label7.setAlignment(java.awt.Label.RIGHT);
    label7.setText("Gateways");
    getContentPane().add(label7, new AbsoluteConstraints(10, 70, 80, -1));

    gateway.setText("localhost");
    getContentPane().add(gateway, new AbsoluteConstraints(100, 70, 110, -1));

    port.setText("3007");
    getContentPane().add(port, new AbsoluteConstraints(280, 70, 70, -1));

    label8.setAlignment(java.awt.Label.RIGHT);
    label8.setText("Client ID");
    getContentPane().add(label8, new AbsoluteConstraints(210, 40, 60, -1));

    clientid.setText("10000000");
    getContentPane().add(clientid, new AbsoluteConstraints(280, 40, 70, -1));

    label9.setAlignment(java.awt.Label.RIGHT);
    label9.setText("Original Ref");
    getContentPane().add(label9, new AbsoluteConstraints(10, 160, 80, -1));

    originalRef.setText("(refunds only)");
    getContentPane().add(originalRef, new AbsoluteConstraints(100, 160, 170, -1));

    refund.setLabel("Refund");
    getContentPane().add(refund, new AbsoluteConstraints(280, 160, -1, -1));

    selectFile.setText("...");
    selectFile.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        selectFileActionPerformed(evt);
      }
    });

    getContentPane().add(selectFile, new AbsoluteConstraints(310, 10, 40, 20));

    pack();
  }

  private void selectFileActionPerformed(java.awt.event.ActionEvent evt)
  {
      if (fc.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
	      certificate.setText( fc.getSelectedFile().getAbsolutePath() );
      }
  }
  
  private void printStack(Exception e) {
    // print the stack trace to a buffer
    ByteArrayOutputStream out = new ByteArrayOutputStream(512);
    PrintStream ps = new PrintStream(out);
    e.printStackTrace( ps );
    ps.flush();
    // split the buffer on carrage returns
    String[] list = matrix.tools.StringTools.split(out.toString(), '\r');
    resultList.addItem("-------- Exception -----------------");
    // print each line to the result list
    for (int x=0;x<list.length;x++)
      resultList.addItem( list[x] );
  }
  
  private void executeActionPerformed(java.awt.event.ActionEvent evt)
  {
    // catch and display any exceptions while creating the webpay object
    try
    {
      Webpay webpay = new Webpay( clientid.getText(), certificate.getText(), passphrase.getText() );
      
      // a single server or comma seperated list
      // this can be host names or IP addresses
      String[] servers = matrix.tools.StringTools.split( gateway.getText(), ',' );
      webpay.setServers( servers );
      webpay.setPort( port.getText() );
      
      webpay.put( "CARDEXPIRYDATE", expMonth.getText() + expYear.getText() );
      webpay.put( "CARDDATA", cardNum.getText() );
      webpay.put( "TOTALAMOUNT", amount.getText() );
      
      // refund?
      if (refund.getState() == true)
      {
	resultList.addItem("-------- Refund -------------------");
	webpay.put( "TRANSACTIONTYPE", "REFUND" );
	webpay.put( "ORIGINALTXNREF", originalRef.getText() );
      } else
      {
	resultList.addItem("-------- Purchase -----------------");
	webpay.put( "TRANSACTIONTYPE", "PURCHASE" );
      }
      
      webpay.put( "INTERFACE", "creditcard" );
      webpay.put( "TAXAMOUNT", "0.00" );
      webpay.put( "TAX", "0.00" );
      
      // catch and display any exceptions while executing the transaction
      try {
	webpay.execute();
      } catch (Exception ee) {
	printStack(ee);
      }
      
      String txnRef = webpay.get( "TXNREFERENCE" );
      resultList.addItem( "Transaction Reference: " + txnRef );
      
      // set the original ref, so we can test the refund
      originalRef.setText( txnRef );
      
      resultList.addItem( "Result: " + webpay.get( "RESULT" ) );
      resultList.addItem( "Response Code: " + webpay.get( "RESPONSECODE" ) );
      resultList.addItem( "Response Text: " + webpay.get( "RESPONSETEXT" ) );
      resultList.addItem( "Authorisation Code: " + webpay.get( "AUTHCODE" ) );
      resultList.addItem( "Pre Auth Number: " + webpay.get( "PREAUTHNUMBER" ) );
      resultList.addItem( "Error Message: " + webpay.get( "ERROR" ) );
      resultList.addItem( "Settlement Date: " + webpay.get( "SETTLEMENTDATE" ) );
    } catch (Exception e)
    {
      printStack(e);
    }
  }
  
  /** Closes the dialog */
  private void closeDialog(java.awt.event.WindowEvent evt)
  {
    setVisible(false);
    dispose();
    System.exit(0);
  }
  
  public static void main(String args[])
  {
    new TestTransaction(new javax.swing.JFrame(), true).show();
  }
}

// these are private classes used for absolute layout

class AbsoluteLayout implements LayoutManager2, Serializable
{

    protected Hashtable constraints;

    public AbsoluteLayout()
    {
        constraints = new Hashtable();
    }

    public void addLayoutComponent(Component component, Object obj)
    {
        if(!(obj instanceof AbsoluteConstraints))
        {
            throw new IllegalArgumentException();
        } else
        {
            constraints.put(component, obj);
            return;
        }
    }

    public void addLayoutComponent(String s, Component component)
    {
        throw new IllegalArgumentException();
    }

    public float getLayoutAlignmentX(Container container)
    {
        return 0.0F;
    }

    public float getLayoutAlignmentY(Container container)
    {
        return 0.0F;
    }

    public void invalidateLayout(Container container)
    {
    }

    public void layoutContainer(Container container)
    {
        Component component;
        AbsoluteConstraints absoluteconstraints;
        int i;
        int j;
        for(Enumeration enumeration = constraints.keys(); enumeration.hasMoreElements(); component.setBounds(absoluteconstraints.x, absoluteconstraints.y, i, j))
        {
            component = (Component)enumeration.nextElement();
            absoluteconstraints = (AbsoluteConstraints)constraints.get(component);
            Dimension dimension = component.getPreferredSize();
            i = absoluteconstraints.getWidth();
            if(i == -1)
                i = dimension.width;
            j = absoluteconstraints.getHeight();
            if(j == -1)
                j = dimension.height;
        }

    }

    public Dimension maximumLayoutSize(Container container)
    {
        return new Dimension(0x7fffffff, 0x7fffffff);
    }

    public Dimension minimumLayoutSize(Container container)
    {
        int i = 0;
        int j = 0;
        for(Enumeration enumeration = constraints.keys(); enumeration.hasMoreElements();)
        {
            Component component = (Component)enumeration.nextElement();
            AbsoluteConstraints absoluteconstraints = (AbsoluteConstraints)constraints.get(component);
            Dimension dimension = component.getMinimumSize();
            int k = absoluteconstraints.getWidth();
            if(k == -1)
                k = dimension.width;
            int l = absoluteconstraints.getHeight();
            if(l == -1)
                l = dimension.height;
            if(absoluteconstraints.x + k > i)
                i = absoluteconstraints.x + k;
            if(absoluteconstraints.y + l > j)
                j = absoluteconstraints.y + l;
        }

        return new Dimension(i, j);
    }

    public Dimension preferredLayoutSize(Container container)
    {
        int i = 0;
        int j = 0;
        for(Enumeration enumeration = constraints.keys(); enumeration.hasMoreElements();)
        {
            Component component = (Component)enumeration.nextElement();
            AbsoluteConstraints absoluteconstraints = (AbsoluteConstraints)constraints.get(component);
            Dimension dimension = component.getPreferredSize();
            int k = absoluteconstraints.getWidth();
            if(k == -1)
                k = dimension.width;
            int l = absoluteconstraints.getHeight();
            if(l == -1)
                l = dimension.height;
            if(absoluteconstraints.x + k > i)
                i = absoluteconstraints.x + k;
            if(absoluteconstraints.y + l > j)
                j = absoluteconstraints.y + l;
        }

        return new Dimension(i, j);
    }

    public void removeLayoutComponent(Component component)
    {
        constraints.remove(component);
    }
}

class AbsoluteConstraints implements Serializable
{
    public int x;
    public int y;
    public int width;
    public int height;
    
    public AbsoluteConstraints(int i, int j, int k, int l)
    {
        x = i;
        y = j;
        width = k;
        height = l;
    }

    public int getHeight()
    {
        return height;
    }

    public int getWidth()
    {
        return width;
    }

    public int getX()
    {
        return x;
    }

    public int getY()
    {
        return y;
    }
}


